#!/bin/sh
echo
echo "# Copyright (c) 2014-2017,by clion007"
echo "# 本脚本仅用于个人研究与学习使用，从未用于产生任何盈利（包括“捐赠”等方式）"
echo "# 未经许可，请勿内置于软件内发布与传播！请勿用于产生盈利活动！请遵守当地法律法规，文明上网。"
echo "# openwrt类固件使用，包括但不限于pandorabox、LEDE、ddwrt等，Padavan系列固件慎用。"
wgetdir="/usr/bin/wget-ssl"
dnsmasqdir="/usr/sbin/dnsmasq"
CRON_FILE=/etc/crontabs/$USER
rm -f /var/lock/opkg.lock
echo
echo -e -n "\e[1;31m 是否检查升级系统已装软件？[y/n]：\e[0m" 
read softupdate
if [ "$softupdate" = "y" ];then
	sleep 2
	echo
	echo -e "\e[1;36m 开始检查并升级系统已装软件\e[0m"
	opkg update
	opkg list-upgradable | grep luci- | cut -d " " -f1 | xargs opkg install
	echo
	echo -e "\e[1;36m 恭喜所有软件已为最新状态\e[0m"
fi
echo
echo -e -n "\e[1;31m 是否检查安装wget软件？[y/n]：\e[0m" 
read wgetinstall
if [ "$wgetinstall" = "y" ];then
	sleep 2
	echo
	echo -e "\e[1;36m 开始检查并安装wget-支持https\e[0m"
	echo
	if [ -f $wgetdir ]; then
		echo -e "\e[1;31m 系统已经安装wget软件\e[0m"
		else
		echo -e "\e[1;31m 没有发现wget开始安装\e[0m"
		opkg update
		opkg install wget
		echo
		if [ -f $wgetdir ]; then
			echo -e "\e[1;36m wget安装成功\e[0m"
			else
			echo -e "\e[1;31m wget安装失败,请到路由器系统软件包手动安装后再试!\e[0m"
			exit 0
		fi	
	fi	
fi
echo
echo -e -n "\e[1;31m 是否需要卸载自带dnsmasq，安装dnsmasq-full？[y/n]：\e[0m" 
read dnsmasqchange
if [ "$dnsmasqchange" = "y" ];then
	echo
	sleep 2
	echo
	echo -e "\e[1;36m 开始卸载dnsmasq并安装dnsmasq-full\e[0m"
	echo
	if [ -f $dnsmasqdir ]; then
		echo -e "\e[1;31m 系统已经安装dnsmasq软件，即将开始卸载\e[0m"
		opkg remove dnsmasq
		echo
		if [ -f $dnsmasqdir ]; then
			echo -e "\e[1;36m dnsmasq卸载失败，请web登录路由器到系统软件包中手动卸载安装后跳过\e[0m"
			exit 0
			else
			echo -e "\e[1;31m dnsmasq卸载成功，即将安装dnsmasq-full\e[0m"
		fi	
		opkg update
		opkg install dnsmasq-full
		echo
		if [ -f $dnsmasqdir ]; then
			echo -e "\e[1;36m dnsmasq-full安装成功\e[0m"
			if [ -f /etc/config/dhcp.opkg ]; then
				cp -f -p /etc/config/dhcp.opkg /etc/config/dhcp
			fi	
			else
			echo -e "\e[1;31m dnsmasq-full安装失败,请web登录路由器到系统软件包中手动安装后再试!\e[0m"
			exit 0
		fi	
		else
		echo -e "\e[1;31m 没有发现dnsmasq开始安装\e[0m"
		opkg update
		opkg install dnsmasq-full
		echo
		if [ -f $dnsmasqdir ]; then
			echo -e "\e[1;36m dnsmasq-full安装成功\e[0m]"
			else
			echo -e "\e[1;31m dnsmasq-full安装失败,请web登录路由器到系统软件包中手动安装后再试!\e[0m"
			exit 0
		fi	
	fi	
	else
	echo -e "\e[1;31m 您已取消变更系统中的dnsmasq软件\e[0m"
fi
echo
clear
echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
echo "+                                                                        +"
echo "+     Install Fq&Noad 4 in 1 script for OpnWrt or LEDE or PandoraBox     +"
echo "+                                                                        +"
echo "+                             Time:`date +'%Y-%m-%d'`                            +"
echo "+                                                                        +"
echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
echo
echo "-----------------------------------------------------------------------------------------------------------------------------------------------------------"
echo -e "\e[1;36m 安装配置说明：1、2脚本可在安装过程中自定义每天更新规则时间；3、4脚本为全自动安装，规则更新时间为每天早上5:28\e[0m"
echo "-----------------------------------------------------------------------------------------------------------------------------------------------------------"
echo
echo -e "\e[1;36m >         1. 安装配置翻墙去广告脚本 \e[0m"
echo
echo -e "\e[1;36m >         2. 安装配置翻墙脚本 \e[0m"
echo
echo -e "\e[1;36m >         3. 安装配置翻墙去广告全自动脚本 \e[0m"
echo
echo -e "\e[1;36m >         4. 安装配置翻墙全自动脚本 \e[0m"
echo
echo -e "\e[1;36m >         5. 安装配置去广告脚本 \e[0m"
echo
echo -e "\e[1;36m >         6. 安装配置去广告全自动脚本 \e[0m"
echo
echo -e "\e[1;36m >         7. 卸载已安装扶墙去广告配置 \e[0m"
echo
echo -e "\e[1;36m >         8. 退出安装 \e[0m"
echo
echo -e -n "\e[1;34m 请输入数字回车执行: \e[0m" 
read Run_Num
if [ "$Run_Num" == "1" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置翻墙去广告脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/fqad.sh -O \
		/tmp/fqad.sh && chmod 775 /tmp/fqad.sh && sh /tmp/fqad.sh
	echo
fi
if [ "$Run_Num" == "2" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置翻墙脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/fq.sh -O \
		/tmp/fq.sh && chmod 775 /tmp/fq.sh && sh /tmp/fq.sh
	echo
fi
if [ "$Run_Num" == "3" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置翻墙去广告全自动脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/fqad_auto.sh -O \
		/tmp/fqad_auto.sh && chmod 775 /tmp/fqad_auto.sh && sh /tmp/fqad_auto.sh
	echo
fi
if [ "$Run_Num" == "4" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置翻墙全自动脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/fq_auto.sh -O \
		/tmp/fq_auto.sh && chmod 775 /tmp/fq_auto.sh && sh /tmp/fq_auto.sh
	echo
fi
if [ "$Run_Num" == "5" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置去广告脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/ad.sh -O \
		/tmp/ad.sh && chmod 775 /tmp/ad.sh && sh /tmp/ad.sh
	echo
fi
if [ "$Run_Num" == "6" ]; then
	echo
	echo -e "\e[1;36m 三秒后开始安装配置去广告全自动脚本......\e[0m"
	echo
	sleep 3
	echo
	wget --no-check-certificate https://raw.githubusercontent.com/clion007/dnsmasq/master/ad_auto.sh -O \
		/tmp/ad_auto.sh && chmod 775 /tmp/ad_auto.sh && sh /tmp/ad_auto.sh
	echo
fi
if [ "$Run_Num" == "7" ]; then
	echo
	echo -e "\e[1;31m 开始卸载已安装扶墙去广告配置 \e[0m"
	rm -f /var/lock/opkg.lock
	sleep 1
	echo
	echo -e "\e[1;31m 删除残留文件夹以及配置 \e[0m"
	rm -rf /etc/dnsmasq
	rm -rf /etc/dnsmasq.d
	if [ -d /etc/dnsmasq.bak ]; then
		mv -f /etc/dnsmasq.bak /etc/dnsmasq
	fi	
	if [ -d /etc/dnsmasq.d.bak ]; then
		mv -f /etc/dnsmasq.d.bak /etc/dnsmasq.d
	fi	
	if [ -f /etc/dnsmasq.conf.bak ]; then
		mv -f /etc/dnsmasq.conf.bak /etc/dnsmasq.conf
	fi	
	echo
	sleep 1
	echo -e "\e[1;31m 删除相关计划任务\e[0m"
	if [ -f /etc/crontabs/$USER.bak ]; then
		mv -f /etc/crontabs/$USER.bak /etc/crontabs/$USER
	fi	
	if [ -f /etc/crontabs/Update_time.conf ]; then
		rm -rf /etc/crontabs/Update_time.conf
	fi	
	if [ -f /etc/crontabs/reboottime.conf ]; then
		rm -rf /etc/crontabs/reboottime.conf
	fi	
	/etc/init.d/cron reload > /dev/null 2>&1
	echo
	sleep 1
	echo -e "\e[1;31m 重启dnsmasq服务\e[0m"
	killall dnsmasq
	/etc/init.d/dnsmasq restart > /dev/null 2>&1
	echo
fi
if [ "$Run_Num" == "8" ]; then
	echo
	echo "\e[1;36m 您已取消安装配置扶墙去广告脚本，三秒后即将退出！\e[0m"
	sleep 3
	exit 0
	echo
fi
